#pragma once
#include "afxwin.h"
#include "Player.h"


//  
struct PlayersStat
{
	PlayersStat(){number_victory = 0; number_roll = 0; players_money = 0;}
	CString players_name;
	CString prize;
	int number_victory;
	int number_roll;
	int players_money;
};

struct WidthColumn
{
	WidthColumn(){left = 0; right = 0;}
	int left;
	int right;
};


// CGameStatistics

class AFX_CLASS_EXPORT CGameStatistics : public CWnd
{
	DECLARE_DYNAMIC(CGameStatistics)

public:
	CGameStatistics();
	virtual ~CGameStatistics();

protected:
	DECLARE_MESSAGE_MAP()
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	//     
	void SetWndPos(const int& x, const int& y, bool center=false);

	void Show(bool show)
	{
		show == true ? ShowWindow(SW_SHOW) : ShowWindow(SW_HIDE);
	}
	//   
	BOOL InitWnd(CWnd* pParent);
	afx_msg void OnPaint();
	//    
	void ShowTable(CDC* pDC);
	void LineTable(CDC* pDC, const int& line_table, const int& first_top);
	PlayersStat m_PlayersStat[4];
	WidthColumn m_WC[5]; //   
	void SetStatistics(CPlayer players[4], const int& number_players, const int& number_games);
	int m_NumberGames;
	int m_NumberPlayers;
	CRect m_Rect;
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
};


