// Money.cpp : implementation file
//

#include "stdafx.h"
#include "nine.h"
#include "Money.h"
#include ".\money.h"
#include "util.h"

const int g_DIAMMONEY = 16;


UINT ROTATEMONEY(LPVOID pParam)
{
	CMoney* pMoney = (CMoney*)pParam;
	CMoney::staticCountProcess++;
	
	

	if(	CMoney::staticStopProcess == false)
	{
		pMoney->m_RotateStop = false;

		
		//  
		CRgn rgn[6];
		CBitmap bmp[6];
		CreateCustomRgn(&rgn[0], IDR_BINARY_MONEYFULL);
		bmp[0].LoadBitmap(IDB_BITMAP_MONEYFULL);

		CreateCustomRgn(&rgn[1], IDR_BINARY_MONEY1);
		bmp[1].LoadBitmap(IDB_BITMAP_MONEY1);

		CreateCustomRgn(&rgn[2], IDR_BINARY_MONEY2);
		bmp[2].LoadBitmap(IDB_BITMAP_MONEY2);


		// 
		CreateCustomRgn(&rgn[3], IDR_BINARY_MONEYLINE); 
		bmp[3].LoadBitmap(IDB_BITMAP_MONEYLINE);

		

		//   
		CreateCustomRgn(&rgn[4], IDR_BINARY_MONEY2);
		bmp[4].LoadBitmap(IDB_BITMAP_MONEY2);

		CreateCustomRgn(&rgn[5], IDR_BINARY_MONEY1);
		bmp[5].LoadBitmap(IDB_BITMAP_MONEY1);



		CDC* pDC = pMoney->GetDC();
		if(pDC != NULL)
		{
			CRgn Rgn;
			while(TRUE)
			{
				
				//  
				//  
				for(int i = 0; i < 6; i++)
				{
					pDC->DrawState(CPoint(0, 0), CSize(g_DIAMMONEY, g_DIAMMONEY), &bmp[i], DST_BITMAP);
					
					//      SetWindowRgn(),
					//   ,  
					//  ,     
					//  .
					CRgn Rgn;
					Rgn.CreateRectRgn(0,0,0,0);
					Rgn.CopyRgn(&rgn[i]);
					pMoney->SetWindowRgn(Rgn, TRUE);

					
					Sleep(20);
					
					if(	CMoney::staticStopProcess == true || 
						pMoney->m_RotateStop == true)
						break;
				}
				

				if(	CMoney::staticStopProcess == true || 
					pMoney->m_RotateStop == true)
				{
					break;
				}
			}// while

			pMoney->ReleaseDC(pDC);
		}// if(pDC != NULL)

	}// if(	CMoney::staticStopProcess == false)

	
	
	CMoney::staticCountProcess--;
	
	return 0;
}




// CMoney

int CMoney::staticCountProcess  = 0;
bool CMoney::staticStopProcess  = false;
bool CMoney::staticSound = true;

IMPLEMENT_DYNAMIC(CMoney, CWnd)
CMoney::CMoney()
: m_pParent(NULL)
, m_RotateStop(true)
{
	
}

CMoney::~CMoney()
{
}


BEGIN_MESSAGE_MAP(CMoney, CWnd)
ON_WM_PAINT()
ON_WM_CREATE()
END_MESSAGE_MAP()


void CMoney::SetParent(CWnd* pParent)
{
	m_pParent = pParent;
}

CPoint CMoney::GetMoneyPos(void)
{
	CPoint result;
	result.x = 0;

	CWnd* pWnd = GetParent();
	if(pWnd != NULL)
	{
		CRect rcChild, rcParent;
		pWnd->GetClientRect(&rcParent);
		GetClientRect(&rcChild);
		ClientToScreen(&rcChild);
		pWnd->ClientToScreen(&rcParent);
		result.x = rcChild.left - rcParent.left;
		result.y = rcChild.top  - rcParent.top;
	}
	
	
	return result;
}

BOOL CMoney::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	HBRUSH brush = CreateSolidBrush(RGB(255,255, 0));
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), NULL/*brush*//*reinterpret_cast<HBRUSH>(COLOR_WINDOW+1)*/, NULL);

	return TRUE;
}



//    
void CMoney::MoneyMoveSound(int left, int top)
{
	MoneyMove(left, top);

	//   ,   .
	if(staticSound == true)
		PlaySound( MAKEINTRESOURCE(IDR_WAVE_MONEY), AfxGetApp()->m_hInstance, SND_RESOURCE | SND_ASYNC);
}

void __fastcall CMoney::MoneyMove(int left, int top)
{
	staticCountProcess++;

	if(CMoney::staticStopProcess == true)
	{
		SetMoneyPos(left, top);
		staticCountProcess--;
		return;
	}


	HANDLE g_h = CreateEvent(0, true, false, "1");

	CPoint pt = GetMoneyPos();
	int y_offset = pt.y - top;
	int x_offset = left - pt.x;

	//   
	int max_offset = max( (y_offset > 0 ? y_offset : y_offset*-1),  (x_offset > 0 ? x_offset : x_offset*-1) );

	int speed = 20;
	if(max_offset > 70)
		speed = 8;
	
	int step_y = y_offset/speed;
	int step_x = x_offset/speed;

	for(int coor = 1; coor < (speed-1); coor++)
	{
		if(staticStopProcess == true)
		{
			coor = speed-1;
			break;
		}

		pt.y -= step_y;
		pt.x += step_x;
		SetMoneyPos(pt);

		//
		WaitForSingleObject(g_h, 10);
	}
		
	pt.x = left;
	pt.y = top;
	SetMoneyPos(pt);

	staticCountProcess--;
}





void CMoney::SetMoneyPos(const int& x, const int& y)
{
	HDWP hdwp = BeginDeferWindowPos(1);
	DeferWindowPos(hdwp, m_hWnd, HWND_TOP, x, y, 0, 0, SWP_NOSIZE);
	EndDeferWindowPos(hdwp);
}
void CMoney::SetMoneyPos(const CPoint& pt)
{
	SetMoneyPos(pt.x, pt.y);
}

void CMoney::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	if(m_RotateStop == true)
	{
		CBitmap money;
		money.LoadBitmap(IDB_BITMAP_MONEYFULL);
		dc.DrawState(CPoint(0, 0), CSize(g_DIAMMONEY, g_DIAMMONEY), &money, DST_BITMAP);
	}


	// Do not call CWnd::OnPaint() for painting messages
}



//   ,
//     .
void CMoney::StopRotate(void)
{
	m_RotateStop = true;
	CRgn rgn;
	CreateCustomRgn(&rgn, IDR_BINARY_MONEYFULL);
	SetWindowRgn(rgn, TRUE);
}

int CMoney::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}

//   
void CMoney::RotateMoney(void)
{
	AfxBeginThread(ROTATEMONEY, this);
}

BOOL CMoney::InitMoney(CWnd* pParent)
{
	BOOL result = Create(NULL, NULL, WS_CHILD|WS_CLIPSIBLINGS, CRect(0,0, g_DIAMMONEY, g_DIAMMONEY), pParent, 0);
	return 0;
}

