
#ifndef UTIL_H
#define UTIL_H


const int MAXNAMEPLAYERS = 11;
const int MAXBUFFERNAMEPLAYER = 12;

//   
const char MAXPLAYERS  = 4;


// global
const CString g_strBEGINNEWPARTY   = "      ?";
const COLORREF g_colorPlayersNames = RGB(255,255,0);
const COLORREF g_colorFlashPlayersNames = RGB(255,255,255);




const char OFFSETCARDSPLAYER1   = 72; //        .. 
const char OFFSETCARDSPLAYERS   = 20; //     
const char OFFSETCARDSTAKEY		= 40; //      Y

const char OFFSETCARDTABLEGOING = 72; //         
const char OFFSETCARDTABLERESET = 10; //        

const char OFFSETXCARDSTAKEPLAYERS = 15; //         
const char OFFSETYCARDSTAKEPLAYERS = 60; //         Y

const char HEIGHTTABLO = 40;
const char WIDTHTABLO  = 120;



//   CCard
#define WM_CARDLBUTTONUP   WM_USER + 30
#define WM_CARDLBUTTONDOWN WM_USER + 35

//      
#define WM_PAGESETTING   WM_USER + 40






#define DELETEPOINT(point)  if(point!=NULL){delete point; point = NULL;}
#define SAFE_RELEASE(point) if(point!=NULL){point->Release(); point = NULL;}
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }




__declspec(dllexport) void Util_DeleteGdiObject(CGdiObject* object);
__declspec(dllexport) void AppProcessMessage(void);
__declspec(dllexport) void AfxMessageBox(const int& number);

__declspec(dllexport) CString IntToStr(const int& number);
__declspec(dllexport) BOOL boolToBOOL(const bool& value);
__declspec(dllexport) bool BOOLTobool(const BOOL& value);

//   
__declspec(dllexport) void __fastcall CreateCustomRgn(CRgn* rgn,  const UINT ID_res);

__declspec(dllexport) void DrawTransparentBitmap(HDC hdc, HBITMAP hBitmap, short xStart,
                           short yStart, COLORREF cTransparentColor);


__declspec(dllexport) HRESULT Util_ReadStringRegKeyCch( HKEY hKey, TCHAR* strRegName, TCHAR* strDest, DWORD cchDest, TCHAR* strDefault );

__declspec(dllexport) HRESULT Util_WriteStringRegKey( HKEY hKey, TCHAR* strRegName, TCHAR* strValue );

__declspec(dllexport) HRESULT Util_ReadIntRegKey( HKEY hKey, TCHAR* strRegName, DWORD* pdwDest, DWORD dwDefault );

__declspec(dllexport) HRESULT Util_WriteIntRegKey( HKEY hKey, TCHAR* strRegName, DWORD dwValue );

__declspec(dllexport) HRESULT Util_ReadBoolRegKey( HKEY hKey, TCHAR* strRegName, BOOL* pbDest, BOOL bDefault );

__declspec(dllexport) HRESULT Util_WriteBoolRegKey( HKEY hKey, TCHAR* strRegName, BOOL bValue );

__declspec(dllexport) HRESULT DXUtil_WriteBinaryRegKey( HKEY hKey, TCHAR* strRegName, void* pParam, DWORD size);
__declspec(dllexport) HRESULT DXUtil_ReadBinaryRegKey( HKEY hKey, TCHAR* strRegName, void* pParam, DWORD size,
                               DWORD* pDefault );




#endif // UTIL_H