#pragma once


// CLabel
class AFX_CLASS_IMPORT CLabel
{

public:
	CLabel();
	~CLabel();

public:
	void Draw(CDC* pDC);
	void SetText(const CString& text);
	void SetColorText(const COLORREF& color_text){m_colorText = color_text;}
	COLORREF GetColorText() {return m_colorText;}
	void InitText(CWnd* pParent);
	void SetFontText(int height, CString name, int bold=400);
	void SetFontText(const LOGFONT& logfont);
	//  
	void SetWidthFont(int width);
	void SetPos(int x, int y, int flag=0);
	void OnTimer(UINT  nIDEvent);
	void SetTempText(CString temp_text);
	void ShowText(bool show);
	void SetShade(bool shade);

private:
	void _settext(const CString& text, bool main_text);
	void RepaintText(CRect rc);
	CRect m_Rect;
	CWnd* m_pParent;
	CString m_memoryText;
	CString m_DrawText;
	CFont m_Font;
	COLORREF m_colorText;
	bool m_ShowText;
	bool m_Shade;
	int m_OffsetShade;
	int m_Flag;
	int X;
	int Y;
	
public:
	CRect GetTextRect(void)
	{
		return m_Rect;
	}
	
};


