// SearchPlayers.cpp : implementation file
//

#include "stdafx.h"
#include "NineKNet1.h"
#include "SearchPlayers.h"
#include ".\searchplayers.h"

//       
UINT ANIMSEARCH(LPVOID pParam)
{
	CSearchPlayers::staticCountProcess++;
	CSearchPlayers* pParent = (CSearchPlayers*)pParam;

	while(true)
	{
		if(	CSearchPlayers::staticStopProcess == true) break;
		if(pParent->m_StopProcess == true) break;

		pParent->m_Animation.SetPos(0);
		for(int i = 0; i < 200; i++)
		{
			if(	CSearchPlayers::staticStopProcess == true) break;
			if(pParent->m_StopProcess == true) break;
			pParent->m_Animation.SetPos(i);
			Sleep(8);
		}
		
	}

	CSearchPlayers::staticCountProcess--;
	return 0;
}

//   CSearchPlayers

int CSearchPlayers::staticCountProcess  = 0;
bool CSearchPlayers::staticStopProcess  = false;

IMPLEMENT_DYNAMIC(CSearchPlayers, CWnd)
CSearchPlayers::CSearchPlayers()
: m_StopProcess(false)
, m_Text(_T(""))
{
}

CSearchPlayers::~CSearchPlayers()
{
}


BEGIN_MESSAGE_MAP(CSearchPlayers, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()



//     


BOOL CSearchPlayers::InitSearchPlayers(CWnd* pParent)
{
	BOOL result = Create(NULL, "", WS_CHILD, CRect(0,0,300,40), pParent, 10);
	
	m_Animation.Create(WS_CHILD|WS_VISIBLE, CRect(0,0, 170, 10), this, 11);
	m_Animation.SetWindowPos(NULL, 120, 15, 0,0, SWP_NOZORDER|SWP_NOSIZE);
	m_Animation.SetRange(0, 200);

	return result;
}

void CSearchPlayers::OnPaint()
{
	CPaintDC dc(this);

	CRect rc;
	GetClientRect(&rc);

	CFont Font;
	Font.CreatePointFont(100, "Microsoft Sans Serif");
	CFont* pDefFont =  dc.SelectObject(&Font);

	CBrush brush;
	brush.CreateSysColorBrush(COLOR_BTNFACE);

	CBrush* pDefBrush = dc.SelectObject(&brush);
	dc.Rectangle(&rc);

	dc.SetBkMode(TRANSPARENT);

	rc.MoveToX(10);
	dc.DrawText(m_Text, &rc, DT_LEFT|DT_VCENTER|DT_SINGLELINE);

	dc.SelectObject(pDefFont);
	dc.SelectObject(pDefBrush);


	// Do not call CWnd::OnPaint() for painting messages
}

void CSearchPlayers::SetPos(int x, int y)
{
	CRect rc;
	GetClientRect(&rc);
	SetWindowPos(NULL, x - rc.Width()/2, y - rc.Height()/2, 0, 0, SWP_NOZORDER|SWP_NOSIZE);
}

void CSearchPlayers::DoAnimation(void)
{
	AfxBeginThread(ANIMSEARCH, this);
}

void CSearchPlayers::ShowSearchPlayers(bool show)
{
	if(show == true)
	{
		this->ShowWindow(SW_SHOW);
		m_StopProcess = false;
		DoAnimation();
	}
	else
	{
		this->ShowWindow(SW_HIDE);
		m_StopProcess = true;
	}
}

void CSearchPlayers::SetText(CString text)
{
	m_Text = text;
	Invalidate();
}
