#pragma once
#include "util.h"


// CPagePublicSetting dialog

class AFX_CLASS_EXPORT CPagePublicSetting : public CPropertyPage
{
	DECLARE_DYNAMIC(CPagePublicSetting)

public:
	CPagePublicSetting();
	virtual ~CPagePublicSetting();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//    CMainFrame
	void SendMainParent(WPARAM wParam, LPARAM lParam);

	afx_msg void OnBnClickedCheckAnim();
	afx_msg void OnBnClickedCheckOpencards();
	afx_msg void OnBnClickedCheckSound();
	afx_msg void OnBnClickedCheckRequestname();
	afx_msg void OnBnClickedCheckChat();

	afx_msg void OnBnClickedRadioMoney100();
	afx_msg void OnBnClickedRadioMoney200();
	afx_msg void OnBnClickedRadioMoney300();

	//         
	void SetCheckRadioMoney(const int amount_money);

	// D     .
	enum CheckButtons {	chbAnim=1, 
						chbOpencards, 
						chbSound, chbRequestname, chbDifficulty, chbChat};
	void SetCheckButtons(CheckButtons check_button);
	

	afx_msg void OnBnClickedCheckDifficultgame();
	bool m_NetGame;
	//      
	void SetSliderRate(int pos);
	//    ,          .
	void DisabledSetting(bool disabled);
};
